- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ thanos_name }}-bucket"
      namespace: "{{ namespace }}"
    policy_name: "{{ thanos_name }}-bucket-to-s3"
    policy_namespace: "{{ (minio_namespace | default('minio'))
                            if (thanos_s3_flavor == 'minio')
                            else ((rgw_namespace | default('radosgw'))
                                  if (thanos_s3_flavor in ['ceph', 'rados', 'radosgw'])
                                  else namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_thanos
                                    and do_thanos_bucket
                                    and thanos_s3_flavor in
                                        ['ceph', 'rados', 'radosgw', 'minio'])
                                else 'absent' }}"
    subject: "{{ (minio_name | default('s3')) if (thanos_s3_flavor == 'minio')
                                              else (rgw_name | default('s3')) }}"
    to:
    - number: "{{ 9000 if (thanos_s3_flavor == 'minio')
                       else 8080 }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ thanos_name }}-bucket"
      namespace: "{{ namespace }}"
    policy_name: "{{ thanos_name }}-bucket-to-{{ ldap_name }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (thanosbucket_do_ldap
                                    and do_network_policy
                                    and do_thanos_bucket
                                    and do_thanos)
                                else 'absent' }}"
    subject: "{{ ldap_name }}"
    to:
    - number: "1389"
    - number: "1636"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ thanos_name }}-bucket"
      namespace: "{{ namespace }}"
    policy_name: "{{ thanos_name }}-bucket-to-{{ lemon_name }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (thanosbucket_do_lemon
                                    and do_network_policy
                                    and do_thanos_bucket
                                    and do_thanos)
                                else 'absent' }}"
    subject: "{{ lemon_name }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/deployment.yaml
  vars:
    cone_cpu_limit: "{{ authproxy_cpu_limit if (thanosbucket_do_lemon
                                                or thanosbucket_do_ldap)
                                            else oauthproxy_cpu_limit }}"
    cone_cpu_request: "{{ authproxy_cpu_request if (thanosbucket_do_lemon
                                                    or thanosbucket_do_ldap)
                                                else oauthproxy_cpu_request }}"
    cone_idx: "{{ 1 if (thanosbucket_do_lemon
                        or thanosbucket_do_ldap
                        or thanosbucket_do_oc)
                    else 0 }}"
    cone_memory_limit: "{{ authproxy_memory_limit if (thanosbucket_do_lemon
                                                      or thanosbucket_do_ldap)
                                                  else oauthproxy_memory_limit }}"
    cone_memory_request: "{{ authproxy_memory_request if (thanosbucket_do_lemon
                                                          or thanosbucket_do_ldap)
                                                      else oauthproxy_memory_request }}"
    cone_tag: "{{ lemon_tag if (thanosbucket_do_lemon
                                or thanosbucket_do_ldap)
                            else oauthproxy_tag }}"
    cpu_limit: "{{ thanos_bucket_cpu_limit }}"
    cpu_request: "{{ thanos_bucket_cpu_request }}"
    dc_data: "{{ lookup('template', 'thanos-bucket.j2') }}"
    dc_name: "{{ thanos_name }}-bucket"
    dc_replicas: "{{ thanos_bucket_replicas }}"
    dc_state: "{{ 'present' if (do_thanos_bucket
                                and do_thanos)
                            else 'absent' }}"
    dc_tag: "{{ thanos_tag }}"
    exporter_idx: "{{ 2 if ((thanosbucket_do_lemon
                             or thanosbucket_do_ldap)
                            and not thanosbucket_do_oc)
                        else 0 }}"
    exporter_tag: "{{ httpexporter_tag }}"
    memory_limit: "{{ thanos_bucket_memory_limit }}"
    memory_request: "{{ thanos_bucket_memory_request }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 9090
    svc_name: "{{ thanos_name }}-bucket"
    svc_state: "{{ 'present' if (do_thanos_bucket
                                 and do_thanos)
                             else 'absent' }}"
  when:
  - not thanosbucket_do_oc
  - not thanosbucket_do_lemon
  - not thanosbucket_do_ldap
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - "{{ ('8080' if (thanosbucket_do_lemon
                      or thanosbucket_do_ldap)
                  else '8443') | int }}"
    - 9090
    svc_gen_keypair: "{{ (thanos_name ~ '-bucket')
                            if (not thanosbucket_do_lemon
                                and not thanosbucket_do_ldap
                                and thanosbucket_do_oc)
                            else False }}"
    svc_name: "{{ thanos_name }}-bucket"
    svc_state: "{{ 'present' if (do_thanos_bucket
                                 and do_thanos)
                             else 'absent' }}"
  when:
  - >
      thanosbucket_do_lemon
      or thanosbucket_do_ldap
      or thanosbucket_do_oc
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 9090
    svc_name: "{{ thanos_name }}-bucket"
    svc_state: "{{ 'present' if (do_exporters
                                 and do_thanos_bucket
                                 and do_thanos)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match | default('') }}"
    policy_name: "prometheus-to-{{ thanos_name }}-bucket"
    policy_state: "{{ 'present' if (do_network_policy
                                    and prometheus_namespace_match | default(False)
                                    and do_exporters
                                    and do_thanos_bucket
                                    and do_thanos)
                                else 'absent' }}"
    subject: "{{ thanos_name }}-bucket"
    to:
    - number: "9090"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ prometheus_name }}"
    policy_name: "{{ prometheus_name }}-to-{{ thanos_name }}-bucket"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_exporters
                                    and do_thanos_bucket
                                    and do_thanos)
                                else 'absent' }}"
    subject: "{{ thanos_name }}-bucket"
    to:
    - number: "9090"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_host: "{{ thanosbucket_fqdn }}"
    route_name: "{{ thanos_name }}-bucket"
    route_state: "{{ 'present' if (do_thanos_bucket
                                   and do_thanos)
                               else 'absent' }}"
    route_target_port: "{{ ('8080' if (thanosbucket_do_lemon
                                       or thanosbucket_do_ldap)
                                   else ('8443' if (thanosbucket_do_oc)
                                                else '9090')) | int }}"
    route_tls_termination: "{{ 'edge' if (thanosbucket_do_lemon
                                          or thanosbucket_do_ldap)
                                      else ('passthrough' if (thanosbucket_do_oc)
                                                else 'edge') }}"
    svc_name: "{{ thanos_name }}-bucket"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ thanos_name }}-bucket"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_thanos_bucket
                                    and do_thanos)
                                else 'absent' }}"
    subject: "{{ thanos_name }}-bucket"
    to:
    - number: "{{ '8080' if (thanosbucket_do_lemon
                             or thanosbucket_do_ldap)
                         else ('8443' if (thanosbucket_do_oc)
                                      else '9090') }}"
- block:
  - block:
    - name: Resolves Thanos Bucket Pods
      async: 30
      changed_when: False
      failed_when: False
      k8s_info:
        api_version: v1
        kind: Pod
        namespace: "{{ namespace }}"
        label_selectors:
        - "name={{ thanos_name }}-bucket"
      no_log: True
      poll: 5
      register: has_pods
    - include_role:
        name: commons
        tasks_from: helpers/restartpod.yaml
      loop: "{{ has_pods.resources }}"
      loop_control:
        label: "{{ p.metadata.name }}"
        loop_var: p
      vars:
        pod_name: "{{ p.metadata.name }}"
        wait_for_apivers: "{{ deployment_apivers }}"
        wait_for_kind: "{{ deployment_kind }}"
        wait_for_objname: "{{ thanos_name }}-bucket"
      when:
      - has_pods is defined
      - has_pods.resources is defined
      - has_pods.resources | length > 0
    when:
    - not (dc_started is changed)
    - thanos_s3 is defined
    - thanos_s3 is changed
  - include_role:
      name: commons
      tasks_from: helpers/wait-for.yaml
    vars:
      check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                             kind=deployment_kind, namespace=namespace,
                             resource_name=(thanos_name ~ '-bucket')) | default('') }}"
      obj_name: "{{ thanos_name }}-bucket"
      retries_for: 300
      wait_for: 30
    when:
    - dc_started is changed
  when:
  - dc_started is defined
  - do_thanos
  - do_thanos_bucket
